routes/web.php
<?php

use Illuminate\Support\Facades\Route;


/**site */
Route::get('/', 'PrincipalController@principal')->name('site.index')->middleware('log.acesso');
Route::get('/sobre-nos', 'SobreNosController@sobreNos')->name('site.sobrenos');
Route::post('/contato', 'ContatoController@salvar')->name('site.contato');
Route::get('/contato', 'ContatoController@contato')->name('site.contato');
Route::get('/login/{erro?}','LoginController@index')->name('site.login');
Route::post('/login','LoginController@autenticar')->name('site.login');

/**app */
Route::middleware('autenticacao:ldap,visitante')->prefix('/app')->group(function () {
    Route::get('/home', 'HomeController@index')->name('app.home');
    Route::get('/sair', 'loginController@sair')->name('app.sair');

    Route::get('/fornecedor', 'FornecedorController@index')->name('app.fornecedor');
    Route::post('/fornecedor/listar', 'FornecedorController@listar')->name('app.fornecedor.listar');
    Route::get('/fornecedor/listar', 'FornecedorController@listar')->name('app.fornecedor.listar');
    Route::get('/fornecedor/adicionar', 'FornecedorController@adicionar')->name('app.fornecedor.adicionar');
    Route::post('/fornecedor/adicionar', 'FornecedorController@adicionar')->name('app.fornecedor.adicionar');
    Route::get('/fornecedor/editar/{id}/{msg?}', 'FornecedorController@editar')->name('app.fornecedor.editar');
    Route::get('/fornecedor/excluir/{id}', 'FornecedorController@excluir')->name('app.fornecedor.excluir');

    Route::resource('produto', 'ProdutoController');
    Route::resource('produto-detalhe','ProdutoDetalheController');
    Route::resource('cliente', 'ClienteController');
    Route::resource('pedido', 'PedidoController');
   // Route::resource('pedido-produto', 'PedidoProdutoController');

    Route::get('pedido-produto/create/{pedido}','PedidoProdutoController@create')->name('pedido-produto.create');
    Route::post('pedido-produto/store/{pedido}','PedidoProdutoController@store')->name('pedido-produto.store');
    //Route::delete('pedido-produto.destroy/{pedido}/{produto}','PedidoProdutoController@destroy')->name('pedido-produto.destroy');
    Route::delete('pedido-produto.destroy/{pedidoProduto}/{pedido_id}','PedidoProdutoController@destroy')->name('pedido-produto.destroy');



});

Route::get('/teste/{p1}/{p2}', 'TesteController@teste')->name('teste');
Route::fallback(function () {
    echo 'rota nao existe.  <a href="' . route('site.index') . '/">clique aqui para ir para a pagina principal</a>';
});

app/Produto.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Produto extends Model
{
    protected $fillable = ['nome','descricao','peso','unidade_id'];


    public function produtoDetalhe()
    {
        return $this->hasOne('App\ProdutoDetalhe');
    }
}

app/Http/Controllers/ProdutoController.php
<?php

namespace App\Http\Controllers;

use App\Produto;
use App\Unidade;
use App\ProdutoDetalhe;
use App\Item;
use App\Fornecedor;
use Illuminate\Http\Request;

class ProdutoController extends Controller
{

    public function index(Request $request)
    {
        $produtos = Item::with(['itemDetalhe','fornecedor'])->paginate(10);

        return view('app.produto.index', [
            'produtos' => $produtos,
            'request' => $request->all()

        ]);


    }


    public function create()
    {
        $unidades = Unidade::all();
        $fornecedores = Fornecedor::all();

        return view(
            'app.produto.create',
            [
                'unidades' => $unidades,
                'fornecedores' => $fornecedores
            ]
        );
    }


    public function store(Request $request)
    {


        $regras = [
            'nome' => 'required|min:3|max:50',
            'descricao' => 'required|min:3|max:2000',
            'peso' => 'required|integer',
            'unidade_id' => 'exists:unidades,id',
            'fornecedor_id' =>'exists:fornecedores,id'

        ];

        $feedback = [
            'required' => ' O campo :attribute deve ser prenchido',
            'nome.min' => 'O Campo nome deve ter no minino 3 caracteres',
            'nome.max' => 'O Campo nome deve ter no maximo 50 caracteres',
            'descricao.min' => 'O Campo descricao deve ter no minino 3 caracteres',
            'descricao.max' => 'O Campo descricao deve ter no maximo 2000 caracteres',
            'peso.integer' => 'o Campo peso deve ser um numnero inteiro',
            'unidade_id.exists' => ' A unidade de medida nao  existe',
            'fornecedor_id.exists' => ' O fornecedor informado  nao  existe',

        ];

        $request->validate($regras, $feedback);

         Item::create($request->all());

        return redirect()->route('produto.index');
    }


    public function show(Produto $produto)
    {

        return view('app.produto.show',[
            'produto' =>$produto
        ]);
    }


    public function edit(Produto $produto)
    {

        $unidades = Unidade::all();
        $fornecedores = Fornecedor::all();


        return view('app.produto.edit', [
           'produto' => $produto,
           'unidades' => $unidades,
           'fornecedores' => $fornecedores

        ]);

       // return view('app.produto.create', ['produto' => $produto,'unidades' => $unidades]);
    }


    public function update(Request $request, Item $produto)
    {

        $regras = [
            'nome' => 'required|min:3|max:50',
            'descricao' => 'required|min:3|max:2000',
            'peso' => 'required|integer',
            'unidade_id' => 'exists:unidades,id',
            'fornecedor_id' =>'exists:fornecedores,id'
        ];

        $feedback = [
            'required' => ' O campo :attribute deve ser prenchido',
            'nome.min' => 'O Campo nome deve ter no minino 3 caracteres',
            'nome.max' => 'O Campo nome deve ter no maximo 50 caracteres',
            'descricao.min' => 'O Campo descricao deve ter no minino 3 caracteres',
            'descricao.max' => 'O Campo descricao deve ter no maximo 2000 caracteres',
            'peso.integer' => 'o Campo peso deve ser um numnero inteiro',
            'unidade_id.exists' => ' A unidade de medida nao  existe',
            'fornecedor_id.exists' => ' O fornecedor informado  nao  existe',

        ];
        $produto->update($request->all());

        return redirect()->route('produto.show', ['produto'=> $produto->id]);

    }


    public function destroy(Produto $produto)
    {
        $produto->delete();
        return redirect()->route('produto.index');

    }
}

resources/views/app/produto/create.blade.php
@extends('app.layouts.basico')
@section('titulo', 'Produto')

@section('conteudo')
    <div class="conteudo-pagina">
        <div class="titulo-pagina-2">
            <p>Cadastrar Produto</p>
        </div>
        <div class="menu">
            <li><a href="{{ route('produto.index') }}">Voltar</a></li>
        </div>
        <div class="informacao-pagina">
            <div style="width: 30%; margin-left: auto; margin-right: auto;">
                <form method="post" action="{{ route('produto.store') }}">
                    @csrf
                    <select name="fornecedor_id">
                        <option value="">Selecione um fornecedor</option>
                        @foreach ($fornecedores as $fornecedor)
                            <option value="{{ $fornecedor->id }}"
                                {{ ($produto->fornecedor_id ?? old('fornecedor_id')) == $fornecedor->id ? 'selected' : '' }}>
                                {{ $fornecedor->nome }}</option>
                        @endforeach
                    </select>
                    {{ $errors->has('fornecedor_id') ? $errors->first('fornecedor_id') : '' }}

                    <input type="text" name="nome" value="{{ $produto->nome ?? old('nome') }}"
                        placeholder="Digite o nome do produto">
                    {{ $errors->has('nome') ? $errors->first('nome') : '' }}
                    <input type="text" name="descricao" placeholder="Digite a descricao do produto"
                        value="{{ $produto->descricao ?? old('descricao') }}">
                    {{ $errors->has('descricao') ? $errors->first('descricao') : '' }}

                    <input type="text" name="peso" placeholder="Digite o peso do produto"
                        value="{{ $produto->peso ?? old('peso') }}">
                    {{ $errors->has('peso') ? $errors->first('peso') : '' }}
                    <select name="unidade_id">
                        <option value="">Selecione a unidade de medida</option>
                        @foreach ($unidades as $unidade)
                            <option value="{{ $unidade->id }}"
                                {{ ($produto->unidade_id ?? old('unidade_id')) == $unidade->id ? 'selected' : '' }}>
                                {{ $unidade->descricao }}</option>
                        @endforeach
                    </select>
                    {{ $errors->has('unidade_id') ? $errors->first('unidade_id') : '' }}

                    <button type="submit" class="borda-preta">Cadastrar</button>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/app/produto/edit.blade.php
@extends('app.layouts.basico')
@section('titulo', 'Editar Produto')

@section('conteudo')
    <div class="conteudo-pagina">
        <div class="titulo-pagina-2">
            <p>Editar Produto</p>
        </div>
        <div class="menu">
            <li><a href="{{ route('produto.index') }}">Voltar</a></li>
        </div>
        <div class="informacao-pagina">
            <div style="width: 30%; margin-left: auto; margin-right: auto;">

                <form method="post" action="{{ route('produto.update', ['produto' => $produto->id]) }}">
                    @csrf
                    @method('PUT')
                    <select name="fornecedor_id">
                        <option value="">Selecione um fornecedor</option>
                        @foreach ($fornecedores as $fornecedor)
                            <option value="{{ $fornecedor->id }}"
                                {{ ($produto->fornecedor_id ?? old('fornecedor_id')) == $fornecedor->id ? 'selected' : '' }}>
                                {{ $fornecedor->nome }}</option>
                        @endforeach
                    </select>
                    {{ $errors->has('fornecedor_id') ? $errors->first('fornecedor_id') : '' }}

                    <input type="text" name="nome" value="{{ $produto->nome ?? old('nome') }}"
                        placeholder="Digite o nome do produto">
                    {{ $errors->has('nome') ? $errors->first('nome') : '' }}
                    <input type="text" name="descricao" placeholder="Digite a descricao do produto"
                        value="{{ $produto->descricao ?? old('descricao') }}">
                    {{ $errors->has('descricao') ? $errors->first('descricao') : '' }}

                    <input type="text" name="peso" placeholder="Digite o peso do produto"
                        value="{{ $produto->peso ?? old('peso') }}">
                    {{ $errors->has('peso') ? $errors->first('peso') : '' }}
                    <select name="unidade_id">
                        <option value="">Selecione a unidade de medida</option>
                        @foreach ($unidades as $unidade)
                            <option value="{{ $unidade->id }}"
                                {{ ($produto->unidade_id ?? old('unidade_id')) == $unidade->id ? 'selected' : '' }}>
                                {{ $unidade->descricao }}</option>
                            {{ $errors->has('unidade_id') ? $errors->first('unidade_id') : '' }}
                        @endforeach
                    </select>
                    <button type="submit" class="borda-preta">Editar</button>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/app/produto/index.blade.php
@extends('app.layouts.basico')
@section('titulo', 'Produto')

@section('conteudo')


    <div class="conteudo-pagina">
        <div class="titulo-pagina-2">
            <p>Listar Produtos</p>
        </div>
        <div class="menu">
            <li><a href="{{ route('produto.create') }}">Cadastrar Novo Produto</a></li>
        </div>
        <div class="informacao-pagina">
            <div style="width: 90%; margin-left: auto; margin-right: auto;">
                <table border="1" width="100%">
                    <thead>
                        <tr>
                            <th>Nome</th>
                            <th>Descricão</th>
                            <th>Fornecedor</th>
                            <th>Site do Fornecedor</th>

                            <th>Peso</th>
                            <th>Unidade</th>
                            <th>Comprimento</th>
                            <th>Altura</th>
                            <th>Largura</th>
                            <th>Ações</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($produtos as $produto)
                            <tr>
                                <td>{{ $produto->nome }}</td>
                                <td>{{ $produto->descricao }}</td>
                                <td>{{ $produto->fornecedor->nome }}</td>
                                <td>{{ $produto->fornecedor->site }}</td>
                                <td>{{ $produto->peso }}</td>
                                <td>{{ $produto->unidade_id }}</td>
                                <td>{{ $produto->itemDetalhe->comprimento ?? '' }}</td>
                                <td>{{ $produto->itemDetalhe->altura ?? '' }}</td>
                                <td>{{ $produto->itemDetalhe->largura ?? '' }}</td>
                                <td>
                                    <a href="{{ route('produto.show', ['produto' => $produto->id]) }}">Visualizar</a>|
                                    <a href="{{ route('produto.edit', ['produto' => $produto->id]) }}">Editar</a>|
                                    <form id="form_{{ $produto->id }}" method="post"
                                        action="{{ route('produto.destroy', ['produto' => $produto->id]) }}">
                                        @method('DELETE')
                                        @csrf
                                        <a href="#"
                                            onclick="document.getElementById('form_{{ $produto->id }}').submit()">Excluir</a>
                                    </form>
                                <td>
                            </tr>
                            <tr>
                                <td colspan="12">
                                    Exibir o ID do pedido(s)
                                    <p>Pedidos</p>
                                    @foreach ($produto->pedidos as $pedido)
                                        <a href="{{ route('pedido-produto.create',['pedido' => $pedido->id]) }}"> Pedido {{ $pedido->id }}</a>
                                    @endforeach
                                </td>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
                {{ $produtos->appends($request)->links() }}
                <br>
                Exbindo {{ $produtos->count() }} Produtos de {{ $produtos->total() }} de(
                {{ $produtos->firstItem() }}
                a {{ $produtos->lastItem() }})
            </div>
        </div>
    </div>
@endsection

resources/views/app/produto/show.blade.php
@extends('app.layouts.basico')
@section('titulo', 'Produto')

@section('conteudo')


    <div class="conteudo-pagina">
        <div class="titulo-pagina-2">
            <p>Visualizar Produto</p>
        </div>
        <div class="menu">
            <li><a href="{{ route('produto.index') }}">Voltar</a></li>
        </div>


        <div class="informacao-pagina">

            <div style="width: 30%; margin-left: auto; margin-right: auto;">
                <table border="1" style="text-align: left ">

                    <tr>
                        <td>ID:</td>
                        <td> {{ $produto->id }}</td>
                    </tr>
                    <tr>
                        <td>Nome:</td>
                        <td> {{ $produto->nome }}</td>
                    </tr>

                    <tr>
                        <td>Descricão:</td>
                        <td> {{ $produto->descricao }}</td>
                    </tr>

                    <tr>
                        <td>Peso:</td>
                        <td> {{ $produto->peso }} Kg</td>
                    </tr>
                    <tr>
                        <td>Unidade de Medidas:</td>
                        <td> {{ $produto->unidade_id }}</td>
                    </tr>
                </table>
            </div>
        </div>

    </div>
@endsection